︠3cbe5ca9-5ad3-4fbc-9612-149644ca8860︠
This code is a test for lawful curves. Here I downloaded a list of elliptic curves over QQ(X^2+2) compiled by a student of William Stein. I ran this code on the list of those curves.
︡f797600a-a872-437e-929c-5fda83288708︡︡
︠73ed59de-cdb0-4904-b321-12dbab60741d︠
f = open('/home/sage/Desktop/table2.txt')
listc = f.read().split('\n')
︡15a8956b-eb8d-407d-af51-babbaa3ba934︡︡
︠0eeb19e8-c8b6-49d3-b4a4-c8eca0fc48a3︠
def quadr_symbol(a,P):
    av = a.valuation(P)
    if av%2==1:
        return -1
        pi = P.number_field().uniformizer(P)
        b = a / pi^av
        return quadr_residue_symbol(b)
︡235aa581-74fc-4a3b-bace-3e96db6c4b4a︡︡
︠c0d5d7a8-f216-4ad8-83c9-4a87e395b313︠
def quadr_residue_symbol(a,P):
    Kr=P.residue_field()
    return Kr(a).is_square() and 1 or -1
︡cbcadcec-4adb-4d52-aef4-f9b25e079bf8︡︡
︠4ca3c94a-d9db-44ce-b1c4-f316541e8c45︠
def cubic_residue_symbol(a,P):
    Kr=P.residue_field()
    try:
        Kr(a).nth_root(3)
    except:
        return -1
    finally:
        return 1
︡b78a08c9-f844-457d-bfee-c690dae46e25︡︡
︠94b6cb73-b4f2-42ce-a035-f411ebd95e04︠
def cubic_symbol(a,P):
    av =  a.valuation(P)
    if av%3!=0:
        return -1
        pi = P.number_field().uniformizer(P)
        b = a / pi^av
        return cubic_residue_symbol(b)
︡4f78fb26-b937-4c60-8707-20c963df4f47︡︡
︠eb308e3d-7f39-4488-8a75-1e5268ef1b75︠
def is_irreducible_complete(gamma,P):    
        if gamma.is_irreducible() == False:
            return False
        else:
             L.<b>=K.extension(gamma)
             l1=len(K.prime_factors(P))
             if l1>1:
                 return False
             else:
                 return True
︡0263e6b8-4df3-4ce3-9297-976006d03153︡︡
︠49543187-8a3a-4e54-93de-829956581759︠
def local_lawful_2(E,P):
    disc=E.discriminant()
    x=polygen(K)
    gamma=x^8-6*E.c4()*x^4-8*E.c6()*x^2-3*(E.c4())^2 
    if quadr_residue_symbol(-3,P)==1 and is_irreducible_complete(gamma)==False:
        return True
  #########################NEED TESTING ###################################          
    elif quadr_residue_symbol(-3,P)!=1 and cubic_symbol(disc,P)==1:
        L.<b>=K.extension(gamma)
        l1=len(L.prime_factors(P))
        L1.<c>=L.extension(x^2+3)
        l2=len(L1.prime_factors(P))
        if l1<l2:
            return True
        else:
            return False
    else:
        return False
︡535a5292-2c90-4d5d-8b14-08d8ac80675a︡︡
︠2d3ef126-6495-45f8-8348-206343b76754︠
def local_lawful_2(E,P):
    disc=E.discriminant()
    x=polygen(K)
    gamma=x^8-6*E.c4()*x^4-8*E.c6()*x^2-3*(E.c4())^2 
    if quadr_residue_symbol(-3,P)==1 and is_irreducible_complete(gamma,P)==False:
        return True
  #########################NEED TESTING ###################################          
    elif quadr_residue_symbol(-3,P)!=1 and cubic_symbol(disc,P)==1:
        L.<b>=K.extension(gamma)
        l1=len(L.prime_factors(P))
        L1.<c>=L.extension(x^2+3)
        l2=len(L1.prime_factors(P))
        if l1<l2:
            return True
        else:
            return False
    else:
        return False
︡fbe4f0c8-926a-4218-be46-85e190a7ba1d︡︡
︠e243311a-666e-45e7-8bb3-21626296951c︠
def is_lawful_local(E,P):         
    K=E.base_field()
    Kr=P.residue_field()
    E1=E.local_minimal_model(P)
    #####################################################    
    disc=E1.discriminant()
    delta=disc.valuation(P)            
    if delta==0:
        return True
    elif delta>0 and E1.j_invariant().valuation(P)<0:
        return False 
    else:
        if Kr.characteristic()%2== 0:
            return local_lawful_2(E1,P)        
        else:
            k=str(E1.kodaira_symbol(P))
            l=quadr_residue_symbol(-1,P)
            #print (k,l,disc)
            ##################################  
            if k=='I0*':
                return True
            ####################################
            elif (k=='III' or k=='III*') and l==1:
                return True
            ####################################
            elif (k=='II' or k=='II*' or k=='IV' or k=='IV*') and quadr_symbol(disc,P)==1:
                return True
            #####################################
            else:
                return False
     ############################################
︡c4537436-7ba8-4ecb-804f-9ae7196b3de8︡︡
︠9d741d00-bd2d-48fa-b53e-77e469282c7d︠
def is_lawful(E):
    K=E.base_field()
    (x,y)=K.signature()
    if x>0:
        return False
    if not E.j_invariant().is_integral():
        return False
    for P,_ in E.conductor().factor():
        if not is_lawful_local(E,P):
            return False
    return True
︡919e4f8f-7758-4edf-b5ee-fb18dd562812︡︡
︠25f15ef5-c581-4575-a72f-2d602cbcb622︠
#This is to check the program#
K.<a> = NumberField(x^2+1)
E=EllipticCurve(K, '49a1')
is_lawful(E)
︡a871a587-9972-4582-b632-bfe6f7ea3e25︡{"stdout": "True"}︡
︠6e0c6fba-4826-4d34-a998-c6f17a22c624︠
K.<a> = NumberField(x^2+2)
for c in listc:
    invs = c.split();
    j = K(invs[4])
    if j.is_integral() and j not in (0,1728,-1728):
        E = EllipticCurve(K,eval(invs[1]))
        if is_lawful(E)==True:
            print E
︡367d549f-c9f9-4e6f-92c6-801a05339a52︡︡
